/* ClassicController */

#import <Cocoa/Cocoa.h>

#include <sys/param.h>

@interface ClassicController : NSObject
{
    IBOutlet id killClassic;
    IBOutlet id startClassic;
    IBOutlet NSWindow *stateWindow;
    IBOutlet NSButton *startButton;
    IBOutlet NSButton *stopButton;
    IBOutlet id prefButton;
    
    IBOutlet id windowontop;
        
    IBOutlet id syspref;
    IBOutlet NSTextField *classictext;
    
    NSTimer			*timer;		// timer for icon refreshs    
    
    int i; // classic state
    int i_old; //old classic state
    char path[MAXPATHLEN]; //value come from sys/param.h


}
- (IBAction)killClassic:(id)sender;
- (IBAction)startClassic:(id)sender;
- (IBAction)opensyspref:(id)sender;
- (IBAction)openstateWindow:(id)sender;
- (IBAction)putontop:(id)sender;
- (IBAction)sendmyMail:(id)sender;
- (IBAction)gotoWeb:(id)sender;

static bool pathForTool(CFStringRef toolName, char path[MAXPATHLEN]);

@end
