#import "ClassicController.h"
#import "SysctlTask.h"

#import <stdlib.h>

#import <Foundation/NSData.h>

#include <unistd.h>
// needed for pathForTool

@implementation ClassicController

- (IBAction)killClassic:(id)sender
{
    int err;
    if(i){ //if running
        err = system("kill -9 `ps ax | grep -i \"Classic Startup.app\" | grep -v grep | cut -c1-6`");
        //printf("%d\n",err);
    }
}

- (IBAction)startClassic:(id)sender
{
    int err;
    if (!i){ // if not already running
        err = system("open -a \"Classic Startup.app\" ");
        //printf("%d\n",err);
    }
}

- (IBAction)opensyspref:(id)sender
{
int err;
err = system("open /System/Library/PreferencePanes/Classic.prefPane/ ");
//printf("%d\n",err);
}

- (IBAction)sendmyMail:(id)sender
{
NSString *emailAddress = @"alexandre.vial@mac.com"; 
NSString *mailToString = @"mailto:"; 
NSString *emailURLString = [mailToString stringByAppendingString:emailAddress]; 
NSURL *emailURL = [NSURL URLWithString:emailURLString]; 
[[NSWorkspace sharedWorkspace] openURL:emailURL];
}

- (IBAction)gotoWeb:(id)sender
{
NSString *emailAddress = @"homepage.mac.com/alexandre.vial/programmation/"; 
NSString *mailToString = @"http://"; 
NSString *emailURLString = [mailToString stringByAppendingString:emailAddress]; 
NSURL *emailURL = [NSURL URLWithString:emailURLString]; 
[[NSWorkspace sharedWorkspace] openURL:emailURL];
}

- (IBAction)openstateWindow:(id)sender
{
    [[NSApplication sharedApplication] activateIgnoringOtherApps:YES];
    [stateWindow makeKeyAndOrderFront:self];
}

- (IBAction)putontop:(id)sender{
       [stateWindow setLevel:([windowontop state] ? NSFloatingWindowLevel : NSNormalWindowLevel)];
}

- (void)setIcon
{
    char *classic_mem = nil;
    NSTask *task = [[NSTask alloc] init];
    NSPipe *newPipe = [[NSPipe alloc] init];//[NSPipe pipe];
    NSFileHandle *readHandle = [newPipe fileHandleForReading];
    NSData *inData = nil;

// test sur Classic 
    [task setStandardOutput:newPipe];
    [task setStandardError: [task standardOutput]];
    // The path to the binary is the first argument that was passed in
    [task setLaunchPath:[NSString stringWithFormat:@"%s",path]];
    [task launch];
    i = 0;
    while ((inData = [readHandle availableData]) && [inData length]){
        NSLog(@"length : %d\n",[inData length]);
        i++; // if somethings come, Classic IS running (or the rights on the tool are wrong...)
        classic_mem=malloc(sizeof(char)*[inData length]);
        [inData getBytes:classic_mem];
        NSLog(@"tool says : %s\n",classic_mem);

        //[task terminate];
    }
    [newPipe release];   
    [task release];
    
    if (i){
        if (i==i_old){ // if the state is the same, we just update memory display (not alway necessary, to improve later !)
            [classictext setStringValue:[NSString stringWithFormat:NSLocalizedString(@"Classic is on, %s",""),classic_mem]];
            [startClassic setTitle:[NSString stringWithFormat:NSLocalizedString(@"Classic is on, %s",""),classic_mem]];
            }
        else { // state was changed from off to on        
            [NSApp setApplicationIconImage:[NSImage imageNamed:@"gai.icns"]];
            //[startButton setTitle:@"Running"];
            [startButton setTitle:NSLocalizedString(@"Running","")];
            [stopButton setTitle:NSLocalizedString(@"Stop","")];
            // dock
            //[killClassic setTitle:@"Quit Classic"];
            [killClassic setTitle:NSLocalizedString(@"Quit Classic","")];
            free(classic_mem);
        }
    }
    else {
        if (i<i_old){ // if the state was changed from on to off
            [NSApp setApplicationIconImage:[NSImage imageNamed:@"triste.icns"]];
            [classictext setStringValue:NSLocalizedString(@"Classic is off.","")];

            [startButton setTitle:NSLocalizedString(@"Start","")];
            [stopButton setTitle:NSLocalizedString(@"Stopped","")];
            //update dock
            [startClassic setTitle:NSLocalizedString(@"Start Classic","")];
            [killClassic setTitle:NSLocalizedString(@"Classic is off","")];
        }
    }
    i_old=i;
}

- (void)setIconFirst
{
    char *classic_mem = nil;
    NSTask *task = [[NSTask alloc] init];
    NSPipe *newPipe = [[NSPipe alloc] init];//[NSPipe pipe];
    NSFileHandle *readHandle = [newPipe fileHandleForReading];
    NSData *inData = nil;
    
// test sur Classic 
    [task setStandardOutput:newPipe];
    [task setStandardError: [task standardOutput]];
    // The path to the binary is the first argument that was passed in
    [task setLaunchPath:[NSString stringWithFormat:@"%s",path]];
    [task launch];
    i = 0;
    while ((inData = [readHandle availableData]) && [inData length]){
        NSLog(@"length : %d\n",[inData length]);
        i++; // if somethings come, Classic IS running (or the rights on the tool are wrong...)
        classic_mem=malloc(sizeof(char)*[inData length]);
        [inData getBytes:classic_mem];
        NSLog(@"tool says : %s\n",classic_mem);
        if (strstr(classic_mem,"host_processor_sets (os/kern)")){
            [[SysctlTask sharedInstance]setValue:path];
            if([[SysctlTask sharedInstance]isAuthenticated])
            {
                [[SysctlTask sharedInstance]deauthenticate];
                NSRunAlertPanel(NSLocalizedString(@"Welcome to ClassicSurvey !",""),NSLocalizedString(@"Your installation is complete, ClassicSurvey can now work.",""), @"Go",NULL,NULL);            
            } else {
                NSRunAlertPanel(NSLocalizedString(@"Error",""),NSLocalizedString(@"Your installation is incomplete, ClassicSurvey can not work.\nBye bye.",""), @"OK",NULL,NULL);
                [newPipe release];   
                [task release];
                free(classic_mem);
                [NSApp terminate:nil];
            }
        }
        //[task terminate]; 
    }    
    [newPipe release];   
    [task release];
    
    if (i){
        [NSApp setApplicationIconImage:[NSImage imageNamed:@"gai.icns"]];
        [classictext setStringValue:[NSString stringWithFormat:NSLocalizedString(@"Classic is on, %s",""),classic_mem]];        
        [startButton setTitle:NSLocalizedString(@"Running","")];
        [stopButton setTitle:NSLocalizedString(@"Stop","")];
        //update dock
        [startClassic setTitle:[NSString stringWithFormat:NSLocalizedString(@"Classic is on, %s",""),classic_mem]];
        [killClassic setTitle:NSLocalizedString(@"Quit Classic","")];

        free(classic_mem);
    }
    else{
        [NSApp setApplicationIconImage:[NSImage imageNamed:@"triste.icns"]];
        [classictext setStringValue:NSLocalizedString(@"Classic is off.","")];
        [startButton setTitle:NSLocalizedString(@"Start","")];
        [stopButton setTitle:NSLocalizedString(@"Stopped","")];
        //update dock
        [startClassic setTitle:NSLocalizedString(@"Start Classic","")];
        [killClassic setTitle:NSLocalizedString(@"Classic is off","")];
        }
    i_old=i; // keep old state in memory
}

- (void)setTimer
{
	double newInterval = 5;

	if (timer) {
		//if (fabs([timer timeInterval] - newInterval) < 0.001)
		//	return;		/* frequency not changed */
		[timer invalidate];
		[timer release];
	}
	timer = [NSTimer scheduledTimerWithTimeInterval:newInterval
		target:self selector:@selector(setIcon) userInfo:nil repeats:YES];
	[timer retain];
}

- (void)applicationDidFinishLaunching:(NSNotification *)notification
{
    if (!pathForTool(CFSTR("PipeTask"), path)) // check for the top-tool
    {
        NSRunAlertPanel(NSLocalizedString(@"Error",""),NSLocalizedString(@"You may have moved the application since you first install it. Please reinstall from the archive.",""), @"OK",NULL,NULL);
        [NSApp terminate:nil];
     }

    [self setIconFirst]; //first run, we check if the good rights are there for top-tool
    [self setIconFirst];
    [self setTimer]; // let's play now !
}

- (void)applicationWillTerminate:(NSNotification *)aNotification 
{
	if (timer) {
		[timer invalidate];
		[timer release];
		timer = nil;
	}
	//[preferences savePreferences];
	[NSApp setApplicationIconImage:[NSImage imageNamed:@"gris.icns"]];	
}

static bool
pathForTool(CFStringRef toolName, char path[MAXPATHLEN])
{
    CFBundleRef bundle;
    CFURLRef resources;
    CFURLRef toolURL;
    Boolean success = true;
    
    bundle = CFBundleGetMainBundle();
    if (!bundle)
        return FALSE;
    
    resources = CFBundleCopyResourcesDirectoryURL(bundle);
    if (!resources)
        return FALSE;
    
    toolURL = CFURLCreateCopyAppendingPathComponent(NULL, resources, toolName, FALSE);
    CFRelease(resources);
    if (!toolURL)
        return FALSE;
    
    success = CFURLGetFileSystemRepresentation(toolURL, TRUE, (UInt8 *)path, MAXPATHLEN);
    
    CFRelease(toolURL);
    CFRelease(bundle); // alex
    return !access(path, X_OK);
}

@end
